/// <reference types="react" />
import { DataType, ErrorMessages, Props, RegisterInput, OnSubmit } from './types';
export default function useForm<Data extends DataType, Name extends keyof Data = keyof Data>({ mode, validationSchema, defaultValues, validationFields, nativeValidation, submitFocusError, }?: Props<Data>): {
    register: (refOrValidateRule: any, validateRule?: RegisterInput | undefined) => ((ref: any) => void) | undefined;
    handleSubmit: (callback: OnSubmit<Data>) => (e: import("react").SyntheticEvent<Element, Event>) => Promise<void>;
    watch: (fieldNames?: string | string[] | undefined, defaultValue?: string | Partial<Data> | undefined) => any;
    unSubscribe: () => void;
    reset: () => void;
    clearError: (name: Name) => void;
    setError: (name: Name, type?: string | undefined, message?: string | undefined, ref?: any) => void;
    setValue: (name: Name, value: Data[Name], shouldValidate?: boolean) => void;
    triggerValidation: (payload: {
        name: Name;
        value?: Data[Name] | undefined;
    } | {
        name: Name;
        value?: Data[Name] | undefined;
    }[]) => Promise<boolean>;
    getValues: () => Data;
    errors: ErrorMessages<Data>;
    formState: {
        isValid: boolean;
        dirty: boolean;
        isSubmitted: boolean;
        submitCount: number;
        touched: unknown[];
        isSubmitting: boolean;
    };
};
